image: node:10.15-slim

stages:
  - build
  - publish

cache:
  paths:
    - node_modules

build:
  stage: build
  artifacts:
    paths:
      - lib
  before_script:
    - npm install -g replace-in-file
    - npm install
  script:
    - replace-in-file "0.0.0-version-placeholder" "${CI_COMMIT_TAG}" package.json
    - npm run build

publish:
  stage: publish
  only: [tags]
  dependencies:
    - build
  before_script:
    - echo "//registry.npmjs.org/:_authToken=${NPM_TOKEN}" > ~/.npmrc
  script:
    - cd lib
    - npm publish --access=public
